public class SPCC_Utilities {

    //Collection Limit
    public static final Integer COLLECTION_SIZE_LIMIT = 999;
    
    //AFE Visualforce Page Names
    public static final String AFE_CREATE_PAGE = 'SPCC_AFECreate';
    public static final String AFE_EDIT_PAGE = 'SPCC_AFEEdit';
    public static final String AFE_VIEW_PAGE = 'SPCC_AFEView';

    //SPCC Profiles
    public static final String SPCC_ADMIN_PROFILE = 'SPCC - Admin';
    public static final String SPCC_USER_PROFILE = 'SPCC - User';

    //SPCC Permission Sets
    public static final String SPCC_ADMIN = 'SPCC_Admin';
    public static final String SPCC_CSR = 'SPCC_CSR';
    public static final String SPCC_EPC = 'SPCC_EPC';
    public static final String SPCC_PROJECT_LEAD = 'SPCC_Project_Lead';
    public static final String SPCC_PROJECT_CONTROLLER = 'SPCC_Project_Controller';

    //SPCC Roles
    public static final String SPCC_CSR_ROLE = 'SPCC_Construction_Site_Rep';
    public static final String SPCC_EPC_ROLE = 'SPCC_Engineering_Procurement_Construction';
    public static final String SPCC_PC_ROLE = 'SPCC_Project_Controller';
    public static final String SPCC_PL_ROLE = 'SPCC_Project_Lead';

    //DML Exception Types
    public static final String FIELD_VALIDATION_EXCEPTION = 'FIELD_CUSTOM_VALIDATION_EXCEPTION';

    //GL Code Categories
    public static final String GL_CODE_CATEGORY_OTHER = 'Miscellaneous';

    //Global Toggle for All Trigger Functions
    public static Boolean executeTriggerCode = true;
    public static Boolean checkForDuplicate = true;

    public static Boolean errorDisplayed = false;
    
    /********************************************Log Error on Page****************************/
    public static void logErrorOnPage(QueryException ex) {
        String message = ex.getMessage();
        logErrorOnPage('Error: ' + message);
    }

    public static void logErrorOnPage(DmlException ex) {
        String message = '';

        //Go through all DML errors
        for(Integer i=0; i < ex.getNumDml(); i++) {
            System.debug('ex.getDmlType: ' + ex.getDmlType(i));
            System.debug('ex.getDmlStatusCode: ' + ex.getDmlStatusCode(i));
            System.debug('ex.getDmlFieldNames: ' + ex.getDmlFieldNames(i));
            //if(ex.getDmlStatusCode(i) != FIELD_VALIDATION_EXCEPTION)
                message += (ex.getDmlMessage(i) + '\n');
        }

        if(!String.isBlank(message))
          logErrorOnPage('Errors: ' + message);
    }

    public static void logErrorOnPage(String errorMessage) {
        ApexPages.addMessage(new ApexPages.Message(ApexPages.Severity.Error, errorMessage, ''));
    }

    public static void logSuccessOnPage(String successMessage) {
        ApexPages.addmessage(new ApexPages.message(ApexPages.severity.CONFIRM, successMessage));
    }
    /*****************************************************************************************/

    /*****************************User Security Function**************************************/
    public Class UserPermissions {
        public Boolean isSystemAdmin {get; private set;}
        public Boolean isAdmin {get; private set;}
        public Boolean isAdminNonPlatform {get; private set;}
        public Boolean isProjectController {get; private set;}
        public Boolean isProjectLead {get; private set;}
        public Boolean isCSR {get; private set;}
        public Boolean isEPC {get; private set;}

        public UserPermissions() {
            this.isSystemAdmin = isUserProfile('System Administrator');
            this.isAdmin = isUserPermissionSet('SPCC_Admin');
            this.isAdminNonPlatform = isUserPermissionSet('SPCC_Admin_Non_Platform_User');
            this.isProjectController = isUserPermissionSet('SPCC_Project_Controller');
            this.isProjectLead = isUserPermissionSet('SPCC_Project_Lead');
            this.isCSR = isUserPermissionSet('SPCC_CSR');
            this.isEPC = isUserPermissionSet('SPCC_EPC');
        }
    }

    private static Boolean isUserProfile(String profileName) {
        return (currentUserProfile == null) ? false : currentUserProfile.Name == profileName;
    }

    private static Boolean isUserPermissionSet(String permissionSet) {
        for(PermissionSetAssignment psa :currentUserPermissionSetAssignments) {
            if(psa.PermissionSet != null && psa.PermissionSet.Name.equals(permissionSet)) {
                return true;
            }
        }

        return false;
    }

    private static Profile currentUserProfile {
        get {
            if(currentUserProfile == null) {
                currentUserProfile = [Select Id, Name
                                      From Profile
                                      Where Id =: UserInfo.getProfileId()];
            }
            return currentUserProfile;
        }
    }

    private static List<PermissionSetAssignment> currentUserPermissionSetAssignments {
        get{
            if(currentUserPermissionSetAssignments == null || currentUserPermissionSetAssignments.isEmpty()) {
                currentUserPermissionSetAssignments = [Select Id, PermissionSet.Name, AssigneeId
                                                       From PermissionSetAssignment
                                                       Where AssigneeId =: UserInfo.getUserId()];
            }
            return currentUserPermissionSetAssignments;
        }
    }
    /**********************************User Related Info**************************************/

    public Class UserDetails {
        public Id userId {get; private set;}
        public Boolean hasContact {get; private set;}
        public Boolean hasAccount {get; private set;}
        public List<Contact> contactList {get; private set;}
        public List<Account> accountList {get; private set;}

        public UserDetails(){
            this.userId =  UserInfo.getUserId(); 
            this.contactList = [SELECT Id, Name, User__c, AccountId
                                FROM Contact
                                WHERE User__c =: userId];
            this.hasContact = (contactList != null && !contactList.isEmpty());

            if(this.hasContact) {
                Set<Id> accountIds = new Set<Id>();
                for (Contact c : contactList){

                    accountIds.add(c.AccountId); 
                }

                this.accountList = [SELECT Id, Name, RecordType.DeveloperName
                                    FROM Account
                                    WHERE Id IN :accountIds
                                    AND RecordType.DeveloperName = 'EPC_Vendor'];
                this.hasAccount = (accountList != null && !accountList.isEmpty());
            }
        }
    }



    /**************************Trigger Handlers and Helpers************************************/
    public static void TriggerAfterDeleteVendorAccountAssignment(List<SPCC_Vendor_Account_Assignment__c> vendorAccountAssignmentList) {
        deleteSharingRulesForVendorContacts(vendorAccountAssignmentList);
    }

    public static void TriggerBeforeInsertVendorAccountAssignment(List<SPCC_Vendor_Account_Assignment__c> vendorAccountAssignmentList) {
        checkForDuplicateVendorAccount(vendorAccountAssignmentList);
    }
    
    public static void TriggerAfterInsertEPCAssignment(List<SPCC_EPC_Assignment__c> epcAssignmentList) {
        createSharingRulesForEPCContacts(epcAssignmentList);
    }

    public static void TriggerAfterDeleteEPCAssignment(List<SPCC_EPC_Assignment__c> epcAssignmentList) {
        deleteSharingRulesForEPCContacts(epcAssignmentList);
    }

    public static void TriggerBeforeInsertEPCAssignment(List<SPCC_EPC_Assignment__c> epcAssignmentList) {
        checkForDuplicateEPCAccount(epcAssignmentList);
    }
    
    public static void TriggerAfterInsertPurchaseOrder(List<SPCC_Purchase_Order__c> purchaseOrderList) {
        createSharingRulesForPurchaseOrder(purchaseOrderList);
    }

    public static void TriggerAfterUpdatePurchaseOrder(List<SPCC_Purchase_Order__c> purchaseOrderList, Map<Id, SPCC_Purchase_Order__c> oldPurchaseOrderMap) {
        System.debug('TriggerAfterUpdatePurchaseOrder');
        updateSharingRulesForPurchaseOrder(purchaseOrderList,oldPurchaseOrderMap);
    }

    public static void TriggerBeforeInsertCSRAssignment(List<SPCC_CSR_Assignment__c> csrAssignmentList) {
        checkForDuplicateCSRAssignments(csrAssignmentList);
    }

    public static void TriggerAfterInsertCSRAssignment(List<SPCC_CSR_Assignment__c> csrAssignmentList) {
        createSharingRulesForCSR(csrAssignmentList);
    }

    public static void TriggerAfterDeleteCSRAssignment(List<SPCC_CSR_Assignment__c> csrAssignmentList) {
        deleteSharingRulesForCSR(csrAssignmentList);
    }

    public static void TriggerAfterInsertContact(List<Contact> contactList) {
        //addSharingRulesForVendorContacts(contactList);
        addSharingRulesForEPCContacts(contactList);
    }

    public static void TriggerAfterDeleteContact(List<Contact> contactList) {
        //deleteSharingRulesForVendorContacts(contactList);
        deleteSharingRulesForEPCContacts(contactList);
        
    }

    public static void TriggerAfterInsertServiceEntrySheet(List<SPCC_Service_Entry_Sheet__c> serviceEntrySheetList) {
        updateIncurredCostOnLineItems(serviceEntrySheetList);
    }

    public static void TriggerAfterUpdateServiceEntrySheet(List<SPCC_Service_Entry_Sheet__c> serviceEntrySheetList, Map<Id, SPCC_Service_Entry_Sheet__c> oldServiceEntrySheetMap) {
        updateIncurredCostOnLineItems(serviceEntrySheetList);
    }

    public static void TriggerAfterDeleteServiceEntrySheet(List<SPCC_Service_Entry_Sheet__c> serviceEntrySheetList) {
        updateIncurredCostOnLineItems(serviceEntrySheetList);
    }

    public static void TriggerBeforeInsertLineItem(List<SPCC_Line_Item__c> lineItemList) {
        validateLineItems(lineItemList);
    }

    public static void TriggerBeforeUpdateLineItem(List<SPCC_Line_Item__c> lineItemList) {
        validateLineItems(lineItemList);
    }

    private static void deleteSharingRulesForVendorContacts(List<SPCC_Vendor_Account_Assignment__c> vendorAccountAssignmentList) {
        Set<Id> accIds = new Set<Id>();
        Set<Id> ewrIds = new Set<Id>();
        //Set<Id> userIds  = new Set<Id>();
        Map<String, SPCC_Vendor_Account_Assignment__c> vendorAccountAssignmentMap = new Map<String, SPCC_Vendor_Account_Assignment__c>();
        //Boolean posExist = false;

        //Create map of account to EWR Ids
        for(SPCC_Vendor_Account_Assignment__c vas : vendorAccountAssignmentList) {
            accIds.add(vas.Vendor_Account__c);
            ewrIds.add(vas.Engineering_Work_Request__c);
            vendorAccountAssignmentMap.put(vas.Vendor_Account__c + '-' + vas.Engineering_Work_Request__c, vas);
        }

        for(SPCC_Purchase_Order__c po: [Select Id, Name, Engineering_Work_Request__c, Vendor_Account__c
                                        From SPCC_Purchase_Order__c
                                        Where Vendor_Account__c In :accIds
                                        And Engineering_Work_Request__c In :ewrIds]) {
            //posExist = true;
            vendorAccountAssignmentMap.get(po.Vendor_Account__c + '-' + po.Engineering_Work_Request__c)
            .addError('Purchase Orders exist with this vendor on this project. Cannot Delete!');              
        }        
    }

    private static void checkForDuplicateVendorAccount(List<SPCC_Vendor_Account_Assignment__c> vendorAccountAssignmentList) {

        Map<String, SPCC_Vendor_Account_Assignment__c> keyVaaMap = new Map<String, SPCC_Vendor_Account_Assignment__c>();
        Set<Id> ewrIds = new Set<Id>();

        //Get Relevant EWR Ids
        for(SPCC_Vendor_Account_Assignment__c vas : vendorAccountAssignmentList) {
            ewrIds.add(vas.Engineering_Work_Request__c);
        }

        //Create EWR-VA <-> VAA Map
        for(SPCC_Vendor_Account_Assignment__c vas : [SELECT Id, Engineering_Work_Request__c, Engineering_Work_Request__r.Name,
                                                            Vendor_Account__c, Vendor_Account__r.Name
                                                     FROM SPCC_Vendor_Account_Assignment__c
                                                     WHERE Engineering_Work_Request__c IN :ewrIds]){


            keyVaaMap.put(vas.Engineering_Work_Request__c + '-' + vas.Vendor_Account__c, vas);
        }


        //Check for duplicate EWR / Vendor combination for VAA
        for(SPCC_Vendor_Account_Assignment__c vas : vendorAccountAssignmentList){
    
                if (keyVaaMap.containsKey(vas.Engineering_Work_Request__c + '-' + vas.Vendor_Account__c)){          

                    //SPCC_Utilities.logErrorOnPage('Engineering Work Request is already assigned with this Vendor');   
                    vas.addError('Engineering Work Request ' + (keyVaaMap.get(vas.Engineering_Work_Request__c + '-' + vas.Vendor_Account__c).Engineering_Work_Request__r.Name == null ? '' :  + keyVaaMap.get(vas.Engineering_Work_Request__c + '-' + vas.Vendor_Account__c).Engineering_Work_Request__r.Name) 
                               + ' is already assigned with Vendor: ' + keyVaaMap.get(vas.Engineering_Work_Request__c + '-'  + vas.Vendor_Account__c).Vendor_Account__r.Name + '.' );   
                }

        } 
            
    }
    
       
    //EPC
    private static void createSharingRulesForEPCContacts(List<SPCC_EPC_Assignment__c> EPCAssignmentList) {
        Set<Id> allAccountIds = new Set<Id>();
        Map<Id, List<Contact>> contactMap = new Map<Id, List<Contact>>();
        List<SPCC_Engineering_Work_Request__Share> ewrSharingRuleList = new List<SPCC_Engineering_Work_Request__Share>();
        List<SPCC_Purchase_Order__Share> poSharingRuleList = new List<SPCC_Purchase_Order__Share>();
        List<SPCC_Purchase_Order__c> poList = new  List<SPCC_Purchase_Order__c>();
        Set<Id> ewrIds = new Set<Id>();
        Set<Id> poIds = new Set<Id>();


        //Get all EPC Account Ids
        for(SPCC_EPC_Assignment__c eas : EPCAssignmentList) {
            allAccountIds.add(eas.EPC_Vendor__c);
            ewrIds.add(eas.Engineering_Work_Request__c);
        }
        
        
        //Get all PO Ids for related EWRs
        for (SPCC_Purchase_Order__c po : [SELECT Id, Engineering_Work_Request__c
                                          FROM SPCC_Purchase_Order__c
                                          WHERE Engineering_Work_Request__c IN :ewrIds]){                 
            poIds.add(po.Id);
            poList.add(po);
        }
                                             

        //Create contact map
        for(Contact c : [Select Id, Name, User__c, AccountId 
                         From Contact 
                         Where AccountId In :allAccountIds
                         And User__c != null]) {
            if(contactMap.containsKey(c.AccountId)) {
                contactMap.get(c.AccountId).add(c);
            } else {
                contactMap.put(c.AccountId, new List<Contact>{c});
            }
        }

        //Create sharing rules for epc contacts to EWRs and POs
        Map<Id, Set<Id>> ewrShareMap = getEwrSharesMap(ewrIds);
        Map<Id, Set<Id>> poShareMap = getPOSharesMap(poIds);
        
        for(SPCC_EPC_Assignment__c eas : EPCAssignmentList) {
            List<Contact> contactList = contactMap.get(eas.EPC_Vendor__c);

            if (contactList != null && !contactList.isEmpty()){

                for(Contact c : contactList) {
                  
                    if(!ewrShareMap.get(eas.Engineering_Work_Request__c).contains(c.User__c)) {
                        SPCC_Engineering_Work_Request__Share ewrShare = new SPCC_Engineering_Work_Request__Share();
                        ewrShare.ParentId = eas.Engineering_Work_Request__c; //Sharing EWR
                        ewrShare.UserOrGroupId = c.User__c;
                        ewrShare.AccessLevel = 'Edit';
                        ewrShare.RowCause = Schema.SPCC_Engineering_Work_Request__Share.RowCause.Manual;
                        ewrSharingRuleList.add(ewrShare);
                    }
                    
                    
                    for (SPCC_Purchase_Order__c po : poList){
                        
                        if(!poShareMap.get(po.Id).contains(c.User__c)) {
                            SPCC_Purchase_Order__Share poShare = new SPCC_Purchase_Order__Share();
                            poShare.ParentId = po.Id; //Sharing PO
                            poShare.UserOrGroupId = c.User__c;
                            poShare.AccessLevel = 'Edit';
                            poShare.RowCause = Schema.SPCC_Purchase_Order__Share.RowCause.Manual;
                            System.debug('Creating sharing rule: ' + poShare);
                            poSharingRuleList.add(poShare);
                        }
                        
                    }
                    
                }   

            }
        }
        
        
        //Commit to Database
        if(!ewrSharingRuleList.isEmpty()) {
            try{
              insert ewrSharingRuleList;
            }
            catch (DmlException ex) {
                System.Debug('Following errors have occoured during saving records: ' + ex.getMessage());
            }
        }
        
        if(!poSharingRuleList.isEmpty()) {
            try{
              insert poSharingRuleList;
            }
            catch (DmlException ex) {
                System.Debug('Following errors have occoured during saving records: ' + ex.getMessage());
            }
        }
    }
    
    
    private static void deleteSharingRulesForEPCContacts(List<SPCC_EPC_Assignment__c> epcAssignmentList) {
        
    Set<Id> accIds = new Set<Id>();
    Set<Id> ewrIds = new Set<Id>();
    Set<Id> userIds  = new Set<Id>();
    Set<Id> poIds = new Set<Id>();

        //Create map of EPC account to EWR Ids
        for(SPCC_EPC_Assignment__c eas : epcAssignmentList) {
            accIds.add(eas.EPC_Vendor__c);
            ewrIds.add(eas.Engineering_Work_Request__c);
        }
        
        
         //Get all PO Ids for related EWRs
         for (SPCC_Purchase_Order__c po : [SELECT Id, Engineering_Work_Request__c
                                           FROM SPCC_Purchase_Order__c
                                           WHERE Engineering_Work_Request__c IN :ewrIds]){
                                          
            poIds.add(po.Id); 
        }

        //Create map of accounts to Contacts
        for (Account acc : [SELECT Id, Name, (SELECT Id, Name, User__c FROM Contacts)
                            FROM Account
                            WHERE Id in :accIds]) {
            for (Contact cnt : acc.Contacts) {
            
                userIds.add(cnt.User__c);
            }
        }

        //Get EWR shares to delete
        List<SPCC_Engineering_Work_Request__Share> ewrSharesToDelete = [SELECT Id, ParentId, UserOrGroupId
                                                                        FROM SPCC_Engineering_Work_Request__Share
                                                                        WHERE ParentId In :ewrIds
                                                                        AND UserOrGroupId In :userIds
                                                                        AND RowCause =: Schema.SPCC_Engineering_Work_Request__Share.RowCause.Manual];
                                                                        
                                                                        
        //Get PO shares to delete
        List<SPCC_Purchase_Order__Share> poSharesToDelete = [SELECT Id, ParentId, UserOrGroupId
                                                             FROM SPCC_Purchase_Order__Share
                                                             WHERE ParentId In :poIds
                                                             AND UserOrGroupId In :userIds
                                                             AND RowCause =: Schema.SPCC_Purchase_Order__Share.RowCause.Manual];

        //Commit to database
        if(ewrSharesToDelete != null && !ewrSharesToDelete.isEmpty()) delete ewrSharesToDelete;
        if(poSharesToDelete != null && !poSharesToDelete.isEmpty()) delete poSharesToDelete;

        //Transfer Ownership of Contact Owned POs to user commiting action - ssd February 16, 2017
        transferPOOwnershipToEWROwner(poIds, userIds);
    }
    
    private static void checkForDuplicateEPCAccount(List<SPCC_EPC_Assignment__c> epcAssignmentList) {

        Map<String, SPCC_EPC_Assignment__c> keyEpcAssignmentMap = new Map<String, SPCC_EPC_Assignment__c>();
        Set<Id> ewrIds = new Set<Id>();

        //Get Relevant EWR Ids
        for(SPCC_EPC_Assignment__c eas : epcAssignmentList) {
            ewrIds.add(eas.Engineering_Work_Request__c);
        }

        //Create EWR-VA <-> EPC Assignemnt Map
        for(SPCC_EPC_Assignment__c eas : [SELECT Id, Engineering_Work_Request__c, Engineering_Work_Request__r.Name,
                                            EPC_Vendor__c, EPC_Vendor__r.Name
                                     FROM SPCC_EPC_Assignment__c
                                     WHERE Engineering_Work_Request__c IN :ewrIds]){


            keyEpcAssignmentMap.put(eas.Engineering_Work_Request__c + '-' + eas.EPC_Vendor__c, eas);
        }


        //Check for duplicate EWR / EPC Vendor combination for EPC Assignemnt
        for(SPCC_EPC_Assignment__c eas : epcAssignmentList){
    
                if (keyEpcAssignmentMap.containsKey(eas.Engineering_Work_Request__c + '-' + eas.EPC_Vendor__c)){          

                    eas.addError('Engineering Work Request ' + (keyEpcAssignmentMap.get(eas.Engineering_Work_Request__c + '-' + eas.EPC_Vendor__c).Engineering_Work_Request__r.Name == null ? '' :  + keyEpcAssignmentMap.get(eas.Engineering_Work_Request__c + '-' + eas.EPC_Vendor__c).Engineering_Work_Request__r.Name) 
                               + ' is already assigned with EPC Vendor: ' + keyEpcAssignmentMap.get(eas.Engineering_Work_Request__c + '-'  + eas.EPC_Vendor__c).EPC_Vendor__r.Name + '.' );   
                }

        } 
            
    }

    private static void updateSharingRulesForPurchaseOrder(List<SPCC_Purchase_Order__c> purchaseOrderList, Map<Id, SPCC_Purchase_Order__c> oldPurchaseOrderMap) {
        List<SPCC_Purchase_Order__Share> poSharingRuleList = new List<SPCC_Purchase_Order__Share>();
        Set<Id> poIdSet = new Set<Id>();

        //Create Inclusive List of parentIds
        for(SPCC_Purchase_Order__c po : purchaseOrderList) {
            if(po.Engineering_Work_Request__c != oldPurchaseOrderMap.get(po.Id).Engineering_Work_Request__c ){
            //    || po.Vendor_Account__c != oldPurchaseOrderMap.get(po.Id).Vendor_Account__c) {
                poIdSet.add(po.Id);
            }
        }

        //delete sharing rules for POs with EWR changed
        delete [Select Id, AccessLevel, ParentId, RowCause, UserOrGroupId
                From SPCC_Purchase_Order__Share
                Where ParentId In :poIdSet
                And RowCause =: Schema.SPCC_Purchase_Order__Share.RowCause.Manual];

        //Create new sharing rules for new Engineering Work Request
        createSharingRulesForPurchaseOrder([Select Id, Name, Engineering_Work_Request__c,OwnerId
                                            From SPCC_Purchase_Order__c
                                            Where Id In :poIdSet]);
    }

    //EPC
    private static void createSharingRulesForPurchaseOrder(List<SPCC_Purchase_Order__c> purchaseOrderList) {
        Map<Id, List<SPCC_Purchase_Order__c>> ewrToPurchaseOrderMap = new Map<Id, List<SPCC_Purchase_Order__c>>();
        //Map<Id, SPCC_Purchase_Order__c> accountToPurchaseOrderMap = new Map<Id, SPCC_Purchase_Order__c>();
        List<SPCC_Purchase_Order__Share> poSharingRuleList = new List<SPCC_Purchase_Order__Share>();
        List<SPCC_Purchase_Order__c> poList = new List<SPCC_Purchase_Order__c>();  
        Set<Id> poIds = new Set<Id>();
        Set<Id> epcAccountIds = new Set<Id>();

        //Create above map
        for(SPCC_Purchase_Order__c po : purchaseOrderList) {
            if(ewrToPurchaseOrderMap.containsKey(po.Engineering_Work_Request__c)) {
                ewrToPurchaseOrderMap.get(po.Engineering_Work_Request__c).add(po);
            } else {
                ewrToPurchaseOrderMap.put(po.Engineering_Work_Request__c, new List<SPCC_Purchase_Order__c>{po});
            }
            //accountToPurchaseOrderMap.put(po.Vendor_Account__c, po);
            poIds.add(po.Id);
            poList.add(po);
        }
        
        for(SPCC_EPC_Assignment__c eas : [SELECT Id, Engineering_Work_Request__c, EPC_Vendor__c
                                          FROM SPCC_EPC_Assignment__c
                                          WHERE Engineering_Work_Request__c IN :ewrToPurchaseOrderMap.keySet()]){
                                              
            epcAccountIds.add(eas.EPC_Vendor__c);                                  
        }
        

        //Get existing shares for purchase orders
        Map<Id, Set<Id>> poShareMap = getPOSharesMap(poIds);

        //Create Sharing rules for CSRs assigned to EWR
        for(SPCC_CSR_Assignment__c ca : [SELECT Id, Name, Engineering_Work_Request__c, Construction_Site_Representative__c,
                                                Construction_Site_Representative__r.isActive
                                         FROM SPCC_CSR_Assignment__c
                                         WHERE Engineering_Work_Request__c In :ewrToPurchaseOrderMap.keySet()
                                         AND Construction_Site_Representative__r.isActive = true]) {   //m.z. 20.4.2018 - FIX issue found in UAT for W-000987 
                                                                                                       //(we can't update sharing rules for inactive user)
            for(SPCC_Purchase_Order__c po : ewrToPurchaseOrderMap.get(ca.Engineering_Work_Request__c)) {
                if(!poShareMap.get(po.Id).contains(ca.Construction_Site_Representative__c)) {
                    System.debug('Sharing Rule->ParentId: ' + po.Id + ' User: ' + ca.Construction_Site_Representative__c);
                    poSharingRuleList.add(new SPCC_Purchase_Order__Share(
                        ParentId = po.Id,
                        UserOrGroupId = ca.Construction_Site_Representative__c,
                        AccessLevel = 'Edit',
                        RowCause = Schema.SPCC_Purchase_Order__Share.RowCause.Manual
                    ));
                }
            }
        }
    
        //Create Sharing rules for EPC Vendor contacts
        for(Contact c : [Select Id, Name, User__c, User__r.isActive, AccountId, User__r.Name
                         From Contact
                         Where AccountId In :epcAccountIds
                         AND User__c != NULL
                         AND User__r.isActive = true]) {  //m.z. 20.4.2018 - FIX issue found in UAT for W-000987 (we can't update sharing rules for inactive user)
            for (SPCC_Purchase_Order__c po : poList){
                if(!poShareMap.get(po.Id).contains(c.User__c)) {
                    System.debug('Sharing Rule->ParentId: ' + po + ' User: ' + c.User__r.Name);
                    poSharingRuleList.add(new SPCC_Purchase_Order__Share(
                        ParentId = po.Id,
                        UserOrGroupId = c.User__c,
                        AccessLevel = 'Edit',
                        RowCause = Schema.SPCC_Purchase_Order__Share.RowCause.Manual));
                }
            }
        }

        insert poSharingRuleList;
    }
    
    private static void checkForDuplicateCSRAssignments(List<SPCC_CSR_Assignment__c> csrAssignmentList) {
        Map<String, SPCC_CSR_Assignment__c> csrAssignmentMap = new Map<String, SPCC_CSR_Assignment__c>();
        Set<Id> ewrIds = new Set<Id>();

        //Get Relevant EWR Ids
        for(SPCC_CSR_Assignment__c ca : csrAssignmentList) {
            ewrIds.add(ca.Engineering_Work_Request__c);
        }

        //Create Map of csr Assigmment for EWR
        for(SPCC_CSR_Assignment__c ca : [Select Id, Name, Engineering_Work_Request__c, Construction_Site_Representative__c,
                                                Engineering_Work_Request__r.Name, Engineering_Work_Request__r.Project_Name__c,
                                                Construction_Site_Representative__r.Name
                                         From SPCC_CSR_Assignment__c
                                         Where Engineering_Work_Request__c In :ewrIds]) {
            csrAssignmentMap.put(ca.Engineering_Work_Request__c + '-' + ca.Construction_Site_Representative__c, ca);
        }

        for(SPCC_CSR_Assignment__c ca : csrAssignmentList) {
            if(csrAssignmentMap.containsKey(ca.Engineering_Work_Request__c + '-' + ca.Construction_Site_Representative__c)){
                ca.addError(('Engineering Work Request ' + csrAssignmentMap.get(ca.Engineering_Work_Request__c + '-' + ca.Construction_Site_Representative__c).Engineering_Work_Request__r.Name 
                               + ' is already assigned with CSR: ' + csrAssignmentMap.get(ca.Engineering_Work_Request__c + '-' + ca.Construction_Site_Representative__c).Construction_Site_Representative__r.Name + '.' ));
            }
        }
    }

    private static void createSharingRulesForCSR(List<SPCC_CSR_Assignment__c> csrAssignmentList) {
        Map<Id, List<SPCC_CSR_Assignment__c>> ewrToCSRAssignmentMap = new Map<Id, List<SPCC_CSR_Assignment__c>>();
        Map<Id, SPCC_Purchase_Order__c> purchaseOrderMap = new Map<Id, SPCC_Purchase_Order__c>();
        List<SPCC_Engineering_Work_Request__Share> ewrSharingRuleList = new List<SPCC_Engineering_Work_Request__Share>();
        List<SPCC_Purchase_Order__Share> poSharingRuleList = new List<SPCC_Purchase_Order__Share>();
        Set<Id> ewrIds = new Set<Id>();

        for(SPCC_CSR_Assignment__c ca : csrAssignmentList) {
            ewrIds.add(ca.Engineering_Work_Request__c);
            if(ewrToCSRAssignmentMap.containsKey(ca.Engineering_Work_Request__c)) 
                ewrToCSRAssignmentMap.get(ca.Engineering_Work_Request__c).add(ca);
            else
                ewrToCSRAssignmentMap.put(ca.Engineering_Work_Request__c, new List<SPCC_CSR_Assignment__c>{ca});
        }

        purchaseOrderMap = new Map<Id, SPCC_Purchase_Order__c>([Select Id, Name, Engineering_Work_Request__c
                                                                From SPCC_Purchase_Order__c
                                                                Where Engineering_Work_Request__c In :ewrIds]);
    

        //Create Sharing Rules for EWR
        Map<Id, Set<Id>> ewrShareMap = getEwrSharesMap(ewrIds);
        for(SPCC_CSR_Assignment__c ca : csrAssignmentList) {
            if(!ewrShareMap.get(ca.Engineering_Work_Request__c).contains(ca.Construction_Site_Representative__c)) {
                SPCC_Engineering_Work_Request__Share ewrShare = new SPCC_Engineering_Work_Request__Share();
                ewrShare.ParentId = ca.Engineering_Work_Request__c; //Sharing ewr
                ewrShare.UserOrGroupId = ca.Construction_Site_Representative__c;
                ewrShare.AccessLevel = 'Read';
                ewrShare.RowCause = Schema.SPCC_Engineering_Work_Request__Share.RowCause.Manual;
                ewrSharingRuleList.add(ewrShare);
            }
        }

        //Create Sharing rules for Purchase Orders
        Map<Id,Set<Id>> poShareMap = getPOSharesMap(purchaseOrderMap.keySet());
        for(SPCC_Purchase_Order__c po : purchaseOrderMap.values()) {
            for(SPCC_CSR_Assignment__c ca : ewrToCSRAssignmentMap.get(po.Engineering_Work_Request__c)) {
                if(!poShareMap.get(po.Id).contains(ca.Construction_Site_Representative__c)) {
                    SPCC_Purchase_Order__Share poShare = new SPCC_Purchase_Order__Share();
                    poShare.ParentId = po.Id;
                    poShare.UserOrGroupId = ca.Construction_Site_Representative__c;
                    poShare.AccessLevel = 'Edit';
                    poShare.RowCause = Schema.SPCC_Purchase_Order__Share.RowCause.Manual;
                    poSharingRuleList.add(poShare);
                }
            }
        }

        //Commit to Database
        if(!ewrSharingRuleList.isEmpty())
            insert ewrSharingRuleList;

        if(!poSharingRuleList.isEmpty())
            insert poSharingRuleList;
    }

    private static void deleteSharingRulesForCSR(List<SPCC_CSR_Assignment__c> csrAssignmentList) {
        Set<Id> ewrIds = new Set<Id>();
        Set<Id> csrIds = new Set<Id>();
        Set<Id> poIds = new Set<Id>();
        Set<String> uniqueKeys = new Set<String>();
        List<SPCC_Engineering_Work_Request__Share> ewrSharingRuleList = new List<SPCC_Engineering_Work_Request__Share>();
        List<SPCC_Purchase_Order__Share> poSharingRuleList = new List<SPCC_Purchase_Order__Share>();

        //Getting unique lists for the filter fields
        for(SPCC_CSR_Assignment__c ca : csrAssignmentList) {
            ewrIds.add(ca.Engineering_Work_Request__c);
            csrIds.add(ca.Construction_Site_Representative__c);
            uniqueKeys.add(ca.Engineering_Work_Request__c + '-' + ca.Construction_Site_Representative__c);
        }

        //Create list of ewrSharingRules to delete
        for(SPCC_Engineering_Work_Request__Share ewrSharingRule : [Select Id, ParentId, UserOrGroupId
                                                                   From SPCC_Engineering_Work_Request__Share
                                                                   Where ParentId In :ewrIds
                                                                   And UserOrGroupId In :csrIds
                                                                   And RowCause = :Schema.SPCC_Engineering_Work_Request__Share.RowCause.Manual]) {
            if(uniqueKeys.contains(ewrSharingRule.ParentId + '-' + ewrSharingRule.UserOrGroupId)) {
                ewrSharingRuleList.add(ewrSharingRule);
            }
        }

        //Create list of PO Ids to query
        for(SPCC_Engineering_Work_Request__c ewr : [Select Id, Name,
                                                           (Select Id, Name
                                                            From Purchase_Orders__r)
                                                    From SPCC_Engineering_Work_Request__c
                                                    Where Id In :ewrIds]) {
            for(SPCC_Purchase_Order__c po : ewr.Purchase_Orders__r) {
                poIds.add(po.Id);
            }
        }

        //Create po sharing rule list to delete
        for(SPCC_Purchase_Order__Share poSharingRule : [Select Id, ParentId, UserOrGroupId
                                                        From SPCC_Purchase_Order__Share
                                                        Where ParentId In :poIds
                                                        And UserOrGroupId In :csrIds
                                                        And RowCause =: Schema.SPCC_Purchase_Order__Share.RowCause.Manual]) {
            poSharingRuleList.add(poSharingRule);
        }

        //Commit to Database
        if(!ewrSharingRuleList.isEmpty())
            delete ewrSharingRuleList;
        if(!poSharingRuleList.isEmpty())
            delete poSharingRuleList;
    }
    
    //EPC
    private static void addSharingRulesForEPCContacts(List<Contact> contactsAdded) {
        Map<Id, List<Contact>> accountToContactsMap = new Map<Id, List<Contact>>();
        Map<Id, List<Id>> accountToEwrIds = new Map<Id, List<Id>>();
        Map<Id, List<Id>> ewrToAccountIds = new Map<Id, List<Id>>();
        Map<Id, List<Id>> accountToPOIds = new Map<Id, List<Id>>();
        List<SPCC_Engineering_Work_Request__Share> ewrShares = new List<SPCC_Engineering_Work_Request__Share>();
        List<SPCC_Purchase_Order__Share> poShares = new List<SPCC_Purchase_Order__Share>();
        Set<Id> ewrIds = new Set<Id>();
        Set<Id> poIds = new Set<Id>();

        //Create map of contacts to Account
        for(Contact cnt : contactsAdded) {
            if(accountToContactsMap.containsKey(cnt.AccountId)) accountToContactsMap.get(cnt.AccountId).add(cnt);
            else accountToContactsMap.put(cnt.AccountId, new List<Contact>{cnt});
        }

        //Create account to EWR Ids list
        for(SPCC_EPC_Assignment__c eas : [SELECT Id, Engineering_Work_Request__c, EPC_Vendor__c
                                          FROM SPCC_EPC_Assignment__c
                                          WHERE EPC_Vendor__c IN :accountToContactsMap.keySet()]) {
            //populate accountToEwrIds
            if(accountToEwrIds.containsKey(eas.EPC_Vendor__c)) accountToEwrIds.get(eas.EPC_Vendor__c).add(eas.Engineering_Work_Request__c);
            else accountToEwrIds.put(eas.EPC_Vendor__c, new List<Id>{eas.Engineering_Work_Request__c});

            //populate ewrToAccountIds
            if(ewrToAccountIds.containsKey(eas.Engineering_Work_Request__c)) ewrToAccountIds.get(eas.Engineering_Work_Request__c).add(eas.EPC_Vendor__c);
            else ewrToAccountIds.put(eas.Engineering_Work_Request__c, new List<Id>{eas.EPC_Vendor__c});

            //populate Id list for verification with exisitin shares
            ewrIds.add(eas.Engineering_Work_Request__c);
        }

        //Create account to PO Id list
        for(SPCC_Purchase_Order__c po : [SELECT Id, Name, Engineering_Work_Request__c
                                         FROM SPCC_Purchase_Order__c
                                         WHERE Engineering_Work_Request__c IN :ewrIds]) {
            //
            if(ewrToAccountIds.containsKey(po.Engineering_Work_Request__c)) {
                for(Id accountId : ewrToAccountIds.get(po.Engineering_Work_Request__c)) {
                    if(accountToPOIds.containsKey(accountId)) accountToPOIds.get(accountId).add(po.Id);
                    else accountToPOIds.put(accountId, new List<Id>{po.Id});
                }
            }

            //populate Id list for verification with exisitin shares
            poIds.add(po.Id);
        }

        //Create Sharing rules
        Map<Id, Set<Id>> ewrShareMap = getEwrSharesMap(ewrIds);
        Map<Id, Set<Id>> poShareMap = getPOSharesMap(poIds);
        for(Id accountId : accountToContactsMap.keySet()) {
            for(Contact cnt : accountToContactsMap.get(accountId)) {
                if(cnt.User__c != null) {
                    //EWR Share
                    if(!accountToEwrIds.isEmpty()) {
                        for(Id ewrId : accountToEwrIds.get(accountId)) {
                            if(ewrShareMap.get(ewrId) != null && !ewrShareMap.get(ewrId).contains(cnt.User__c)) {
                                SPCC_Engineering_Work_Request__Share ewrShare = new SPCC_Engineering_Work_Request__Share();
                                ewrShare.ParentId =  ewrId;
                                ewrShare.UserOrGroupId = cnt.User__c;
                                ewrShare.AccessLevel = 'Edit';
                                ewrShare.RowCause = Schema.SPCC_Engineering_Work_Request__Share.RowCause.Manual;
                                ewrShares.add(ewrShare);
                            }
                        }
                    }

                    //PO Share
                    if(!poShareMap.isEmpty()) {
                        for(Id poId : accountToPOIds.get(accountId)) {
                            if(!poShareMap.get(poId).contains(cnt.User__c)) {
                                SPCC_Purchase_Order__Share poShare = new SPCC_Purchase_Order__Share();
                                poShare.ParentId = poId;
                                poShare.UserOrGroupId = cnt.User__c;
                                poShare.AccessLevel = 'Edit';
                                poShare.RowCause = Schema.SPCC_Purchase_Order__Share.RowCause.Manual;
                                poShares.add(poShare);
                            }
                        }
                    }
                }
            }
        }

        //Commit to database
        if(!ewrShares.isEmpty()) insert ewrShares;
        if(!poShares.isEmpty()) insert poShares;
    }

    private static void deleteSharingRulesForEPCContacts(List<Contact> contactsDeleted) {
        Set<Id> userIds = new Set<Id>();

        //Create list of User Ids
        for(Contact cnt : contactsDeleted) {
            userIds.add(cnt.User__c);
        }

        //Get list of EWR Shares for that user
        List<SPCC_Engineering_Work_Request__Share> ewrSharesToDelete = [Select Id, ParentId, UserOrGroupId
                                                                        From SPCC_Engineering_Work_Request__Share
                                                                        Where UserOrGroupId In :userIds];

        //Get list of PO Shares for that user
        List<SPCC_Purchase_Order__Share> poSharesToDelete = [Select Id, ParentId, UserOrGroupId
                                                             From SPCC_Purchase_Order__Share
                                                             Where UserOrGroupId In :userIds
                                                             And RowCause =: Schema.SPCC_Purchase_Order__Share.RowCause.Manual];

        //Delete shares
        if(ewrSharesToDelete != null && !ewrSharesToDelete.isEmpty()) delete ewrSharesToDelete;
        if(poSharesToDelete != null && !poSharesToDelete.isEmpty()) delete poSharesToDelete;

        transferPOOwnershipToEWROwner(null, userIds);
    }

    private static void updateIncurredCostOnLineItems(List<SPCC_Service_Entry_Sheet__c> serviceEntrySheets) {
        Set<Id> lineItemIds = new Set<Id>();
        Map<Id, SPCC_Line_Item__c> lineItemMap;


        //Create Map of Service Entry Sheets to LineItem
        for(SPCC_Service_Entry_Sheet__c serviceEntrySheet : serviceEntrySheets) {
            lineItemIds.add(serviceEntrySheet.Line_Item__c);
        }
    

        //Get Line Items affected
        lineItemMap = new Map<Id, SPCC_Line_Item__c>([Select Id, Name, Incurred_Cost__c
                                                      From SPCC_Line_Item__c
                                                      Where Id In :lineItemIds]);
         
        //m.z.: 8.3.2018 fix for W-001069 
        //clear incurred cost on affected LIs, we will recalculate anyway
        //this will handle the case if we delete SES ticket and there are no more tickets on affected LI
        for (SPCC_Line_Item__c li : lineItemMap.values()){
            li.Incurred_Cost__c = 0;
        }  
        
        //Get Aggregare Sum of Service Entry Sheets amount grouped and filtered by lineItemsToUpdate
        for(AggregateResult result : [Select SUM(Amount__c) totalAmount, Line_Item__c
                                      From SPCC_Service_Entry_Sheet__c
                                      Where Line_Item__c In :lineItemIds
                                      Group By Line_Item__c]) {
            SPCC_Line_Item__c lineItem = lineItemMap.get((String) result.get('Line_Item__c'));
            Decimal totalAmount = (Decimal) result.get('totalAmount');
            lineItem.Incurred_Cost__c = totalAmount;
        }
        update lineItemMap.values();
    }

    private static void validateLineItems(List<SPCC_Line_Item__c> lineItemList) {
        Set<Id> purchaseOrderIdSet = new Set<Id>();
        Set<Id> costElementIdSet = new Set<Id>();
        Set<Id> updatedLineItemIdSet = new Set<Id>();
        Map<String, SPCC_Line_Item__c> itemNumberCheckMap = new Map<String, SPCC_Line_Item__c>();

        //Create Set and check new records
        for(SPCC_Line_Item__c lineItem : lineItemList) {
            //Create Sets for additional checks (Theses will be required since Master detail so no null check)
            purchaseOrderIdSet.add(lineItem.Purchase_Order__c);
            costElementIdSet.add(lineItem.Cost_Element__c);

            if(lineItem.Id != null) updatedLineItemIdSet.add(lineItem.Id); //save ids if update

            //line item number check
            if(itemNumberCheckMap.containsKey(lineItem.Purchase_Order__c+'-'+lineItem.Item__c)) {
                lineItem.addError('Duplicate item number found in current set.');
            } else {
                itemNumberCheckMap.put(lineItem.Purchase_Order__c+'-'+lineItem.Item__c, lineItem);
            }
        }

        //Check with lineItems already in database
        for(SPCC_Line_Item__c lineItem : [Select Id, Name, Cost_Element__c, Purchase_Order__c, 
                                                 Purchase_Order__r.Name,
                                                 Cost_Element__r.GL_Number__c, Committed_Amount__c,
                                                 Item__c, Short_Text__c
                                          From SPCC_Line_Item__c
                                          Where Id Not In :updatedLineItemIdSet
                                          And Purchase_Order__c In :purchaseOrderIdSet]) {
            if(itemNumberCheckMap.containsKey(lineItem.Purchase_Order__c+'-'+lineItem.Item__c)) {
                itemNumberCheckMap.get(lineItem.Purchase_Order__c+'-'+lineItem.Item__c).addError(
                    'Duplicate line item number found in database.');
            }
        }

    }

    private static void transferPOOwnershipToEWROwner(Set<Id> poIds, Set<Id> userIds) {
        //Transfer Ownership of Contact Owned POs to user commiting action - ssd February 16, 2017
        List<SPCC_Purchase_Order__c> purchaseOrderList = new List<SPCC_Purchase_Order__c>();
        purchaseOrderList = (poIds != null) ? 
                            [SELECT Id, Name, OwnerId, Engineering_Work_Request__r.OwnerId
                             FROM SPCC_Purchase_Order__c
                             Where OwnerId In :userIds
                             And Id In :poIds] :
                            [SELECT Id, Name, OwnerId, Engineering_Work_Request__r.OwnerId
                             FROM SPCC_Purchase_Order__c
                             Where OwnerId In :userIds];

        //Before transfering ownership need to preserve existing manual sharing rules
        //for POs affected since changing ownership resets the sharing rules
        Set<Id> affectedPoIds = new Set<Id>();
        List<SPCC_Purchase_Order__Share> poSharesToPreserve = new List<SPCC_Purchase_Order__Share>();
        for(SPCC_Purchase_Order__c po : purchaseOrderList) {
            affectedPoIds.add(po.Id);
        }
        for(SPCC_Purchase_Order__Share poShare : [Select Id, ParentId, UserOrGroupId, AccessLevel, RowCause
                                                  From SPCC_Purchase_Order__Share
                                                  Where ParentId In :affectedPoIds
                                                  And RowCause =: Schema.SPCC_Purchase_Order__Share.RowCause.Manual]) {
            poSharesToPreserve.add(
                new SPCC_Purchase_Order__Share(
                    ParentId = poShare.parentId,
                    UserOrGroupId = poShare.UserOrGroupId,
                    AccessLevel = poShare.AccessLevel,
                    RowCause = poShare.RowCause
                )
            );
        }

        //Update Owners on affected POs
        for(SPCC_Purchase_Order__c po : purchaseOrderList) {
            po.OwnerId = po.Engineering_Work_Request__r.OwnerId;
        }       

        //Commit to Database
        SavePoint sp = Database.setSavepoint();
        try {
            update purchaseOrderList;
            insert poSharesToPreserve;
        } catch (DmlException ex) {
            Database.rollback(sp);
        }
    }

    private static Map<Id, Set<Id>> getEwrSharesMap(Set<Id> ewrIds) {
        Map<Id, Set<Id>> ewrShareMap = new Map<Id, Set<Id>>();
        for(SPCC_Engineering_Work_Request__Share ewrShare : [Select Id, ParentId, UserOrGroupId
                                                             From SPCC_Engineering_Work_Request__Share
                                                             Where ParentId In :ewrIds]) {
            if(ewrShareMap.containsKey(ewrShare.ParentId)) ewrShareMap.get(ewrShare.ParentId).add(ewrShare.UserOrGroupId);
            else ewrShareMap.put(ewrShare.ParentId, new Set<Id>{ewrShare.UserOrGroupId});
        }
        return ewrShareMap;
    }

    private static Map<Id, Set<Id>> getPOSharesMap(Set<Id> poIds) {
        Map<Id, Set<Id>> poShareMap = new Map<Id, Set<Id>>();
        for(SPCC_Purchase_Order__Share poShare : [Select Id, ParentId, UserOrGroupId
                                                             From SPCC_Purchase_Order__Share
                                                             Where ParentId In :poIds]) {
            if(poShareMap.containsKey(poShare.ParentId)) poShareMap.get(poShare.ParentId).add(poShare.UserOrGroupId);
            else poShareMap.put(poShare.ParentId, new Set<Id>{poShare.UserOrGroupId});
        }
        return poShareMap;
    }
    

    public static Boolean isNumeric(String s){
        Boolean ReturnValue;
        try{
            Decimal.valueOf(s);
            ReturnValue = TRUE; 
        } catch (Exception e) {
            ReturnValue = FALSE;
        }
        return ReturnValue;
    }
    
    /******************************************************************************************/
}